﻿------------------------------------------------------------------------------------
-- NiceColorize by Mr.Dio (Бурелов-СвежевательДуш) Version 1.2 (27th February 2014)
------------------------------------------------------------------------------------
--
-- Name Colorize Module
--
------------------------------------------------------------------------------------
-- NiceColorize
------------------------------------------------------------------------------------

local Cfg = NiceConfig

if Cfg.NamesColorize.ModuleEnable then

	local DefaultFont, DefaultSize, DefaultStyle  = PlayerName:GetFont()

	local NCFrame = CreateFrame("Frame")

	NCFrame:SetScript("OnUpdate", function()

	-- Player Frame

		if PlayerFrame:IsShown() then
			if UnitIsPlayer("player") then
						local C = RAID_CLASS_COLORS[select(2, UnitClass("player"))]

				PlayerName:SetTextColor(C.r, C.g, C.b)
				if IsInRaid() then
					local inInstance, instanceType = IsInInstance()

					if (inInstance and (instanceType ~= "arena")) then				

						local NumGroupMembers = GetNumGroupMembers()
		
						for i=1, MAX_RAID_MEMBERS do
								if ( i <= NumGroupMembers ) then
								local Name, Rank, SubGroup = GetRaidRosterInfo(i)
			
									if ( Name == UnitName("player") ) then
											PlayerName:SetText("("..SubGroup..") "..UnitName("player"))
										end
							end
							end
					end
				else
					PlayerName:SetText(UnitName("player"))
				end
				else
				PlayerName:SetTextColor(1, 0.8, 0)
			end

			PlayerName:SetFont(DefaultFont, DefaultSize, "OUTLINE")
		end

	-- Target Frame

		if TargetFrame:IsShown() then
			if UnitIsPlayer("target") then
				local C = RAID_CLASS_COLORS[select(2, UnitClass("target"))]

				TargetFrameTextureFrameName:SetTextColor(C.r, C.g, C.b)

				if IsInRaid() then
					local inInstance, instanceType = IsInInstance()

					if (inInstance and (instanceType ~= "arena")) then				

						local NumGroupMembers = GetNumGroupMembers()
		
						for i=1, MAX_RAID_MEMBERS do
								if ( i <= NumGroupMembers ) then
								local Name, Rank, SubGroup = GetRaidRosterInfo(i)
			
									if ( Name == GetUnitName("target", true) ) then
											TargetFrameTextureFrameName:SetText("("..SubGroup..") "..GetUnitName("target", false))
										end
							end
							end
					end
				end

			else
				TargetFrameTextureFrameName:SetTextColor(1, 0.8, 0)
			end

			local R, G, B, _ = TargetFrameNameBackground:GetVertexColor()

			TargetFrameNameBackground:SetTexture(R, G, B, 0.25)
			TargetFrameTextureFrameName:SetFont(DefaultFont, DefaultSize, "OUTLINE")

		end

	-- Target Target Frame

		if TargetFrameToTTextureFrame:IsShown() then
			if UnitIsPlayer("targettarget") then
						local C = RAID_CLASS_COLORS[select(2, UnitClass("targettarget"))]

				TargetFrameToTTextureFrameName:SetTextColor(C.r, C.g, C.b)
				else
				TargetFrameToTTextureFrameName:SetTextColor(1, 0.8, 0)
			end
			TargetFrameToTTextureFrameName:SetFont(DefaultFont, DefaultSize, "OUTLINE")
		end

	-- Focus Frame

		if FocusFrame:IsShown() then
			if UnitIsPlayer("focus") then
						local C = RAID_CLASS_COLORS[select(2, UnitClass("focus"))]

				FocusFrameTextureFrameName:SetTextColor(C.r, C.g, C.b)

				if IsInRaid() then
					local inInstance, instanceType = IsInInstance()

					if (inInstance and (instanceType ~= "arena")) then				

						local NumGroupMembers = GetNumGroupMembers()
		
						for i=1, MAX_RAID_MEMBERS do
								if ( i <= NumGroupMembers ) then
								local Name, Rank, SubGroup = GetRaidRosterInfo(i)
			
									if ( Name == GetUnitName("focus", true) ) then
											FocusFrameTextureFrameName:SetText("("..SubGroup..") "..GetUnitName("focus", false))
										end
							end
							end
					end
				end
				else
				FocusFrameTextureFrameName:SetTextColor(1, 0.8, 0)
			end

			local R, G, B, _ = FocusFrameNameBackground:GetVertexColor()

			FocusFrameNameBackground:SetTexture(R, G, B, 0.25)
			FocusFrameTextureFrameName:SetFont(DefaultFont, DefaultSize, "OUTLINE")
		end

	-- Focus Target Frame

		if FocusFrameToTTextureFrame:IsShown() then
			if UnitIsPlayer("focustarget") then
						local C = RAID_CLASS_COLORS[select(2, UnitClass("focustarget"))]

				FocusFrameToTTextureFrameName:SetTextColor(C.r, C.g, C.b)
				else
				FocusFrameToTTextureFrameName:SetTextColor(1, 0.8, 0)
			end
			FocusFrameToTTextureFrameName:SetFont(DefaultFont, DefaultSize, "OUTLINE")
		end

	-- Party Frame

		for i, PF in pairs({PartyMemberFrame1, PartyMemberFrame2, PartyMemberFrame3, PartyMemberFrame4}) do
			if PF:IsShown() then
				if UnitIsPlayer("party"..i) then
							local C = RAID_CLASS_COLORS[select(2, UnitClass("party"..i))]

					if C then
						_G["PartyMemberFrame"..i.."Name"]:SetTextColor(C.r, C.g, C.b)
					end
					else
					_G["PartyMemberFrame"..i.."Name"]:SetTextColor(1, 0.8, 0)
				end
				_G["PartyMemberFrame"..i.."Name"]:SetText(GetUnitName("party"..i, false))
				_G["PartyMemberFrame"..i.."Name"]:SetFont(DefaultFont, DefaultSize, "OUTLINE")
			end
		end
		
		for i, CPF in pairs({CompactPartyFrameMember1, CompactPartyFrameMember2, CompactPartyFrameMember3, CompactPartyFrameMember4, CompactPartyFrameMember5}) do
			if CPF:IsShown() then
				if UnitIsPlayer("party"..i) then
							local C = RAID_CLASS_COLORS[select(2, UnitClass("party"..i))]

					if C then
						_G["CompactPartyFrameMember"..i.."Name"]:SetTextColor(C.r, C.g, C.b)
					end
					else
					_G["CompactPartyFrameMember"..i.."Name"]:SetTextColor(1, 0.8, 0)
				end
				_G["CompactPartyFrameMember"..i.."Name"]:SetText(GetUnitName("party"..i, false))
				_G["CompactPartyFrameMember"..i.."Name"]:SetFont(DefaultFont, DefaultSize, "OUTLINE")
			end
		end

	-- Raid Frame

		if CompactRaidFrameContainer:IsShown() then
			for i=1, MAX_RAID_MEMBERS do
				if _G["CompactRaidFrame"..i] then
					local n,cc="CompactUnitFrameProfilesGeneralOptionsFrame" cc = _G[n.."UseClassColors"]
					if not cc:GetChecked() then
						if UnitIsPlayer(_G["CompactRaidFrame"..i.."Name"]:GetText()) then
							local c = RAID_CLASS_COLORS[select(2, UnitClass(_G["CompactRaidFrame"..i.."Name"]:GetText()))]
							_G["CompactRaidFrame"..i.."Name"]:SetTextColor(c.r, c.g, c.b)
						else
							_G["CompactRaidFrame"..i.."Name"]:SetTextColor(1, 1, 1)
						end
						_G["CompactRaidFrame"..i.."Name"]:SetFont(DefaultFont, DefaultSize, "OUTLINE")
					else
						_G["CompactRaidFrame"..i.."Name"]:SetTextColor(1, 1, 1)
						_G["CompactRaidFrame"..i.."Name"]:SetFont(DefaultFont, DefaultSize, "OUTLINE")
					end
				end
			end
			for a=1, MAX_RAID_GROUPS do
				for i=1, MAX_RAID_MEMBERS do
					if _G["CompactRaidGroup"..a.."Member"..i] then
						local n,cc="CompactUnitFrameProfilesGeneralOptionsFrame" cc = _G[n.."UseClassColors"]
						if not cc:GetChecked() then
							if UnitIsPlayer(_G["CompactRaidGroup"..a.."Member"..i.."Name"]:GetText()) then
								local c = RAID_CLASS_COLORS[select(2, UnitClass(_G["CompactRaidGroup"..a.."Member"..i.."Name"]:GetText()))]
								_G["CompactRaidGroup"..a.."Member"..i.."Name"]:SetTextColor(c.r, c.g, c.b)
							else
								_G["CompactRaidGroup"..a.."Member"..i.."Name"]:SetTextColor(1, 1, 1)
							end
							_G["CompactRaidGroup"..a.."Member"..i.."Name"]:SetFont(DefaultFont, DefaultSize, "OUTLINE")
						else
							_G["CompactRaidGroup"..a.."Member"..i.."Name"]:SetTextColor(1, 1, 1)
							_G["CompactRaidGroup"..a.."Member"..i.."Name"]:SetFont(DefaultFont, DefaultSize, "OUTLINE")
						end
					end
				end
			end
		end

	-- Arena Frame

		for i, AF in pairs({ArenaEnemyFrame1,ArenaEnemyFrame2,ArenaEnemyFrame3,ArenaEnemyFrame4,ArenaEnemyFrame5}) do
			if AF:IsShown() then
				local C = RAID_CLASS_COLORS[select(2, UnitClass("arena"..i))]
				if C then
					_G["ArenaEnemyFrame"..i.."Name"]:SetTextColor(C.r, C.g, C.b)
				end
				_G["ArenaEnemyFrame"..i.."Name"]:SetFont(DefaultFont, DefaultSize, "OUTLINE")
			end
		end

	-- Boss Frame

		for i, BF in pairs({Boss1TargetFrame,Boss2TargetFrame,Boss3TargetFrame,Boss4TargetFrame,Boss5TargetFrame}) do
			if BF:IsShown() then
				local R, G, B, _ = select(3, BF:GetRegions()):GetVertexColor()

				select(3, BF:GetRegions()):SetTexture(R, G, B, 0.25)
				_G["Boss"..i.."TargetFrameTextureFrameName"]:SetFont(DefaultFont, DefaultSize, "OUTLINE")
			end
		end

	-- Pet Frame

		if PetFrame:IsShown() then
			PetName:SetFont(DefaultFont, DefaultSize, "OUTLINE")
		end

	end)
end

if Cfg.NamesColorize.RaidFix then
	local NCRaidFixFrame = CreateFrame("Frame")

	NCRaidFixFrame:RegisterEvent("PLAYER_REGEN_ENABLED")

	NCRaidFixFrame:SetScript("OnEvent", function()
		if IsInRaid() then
			local container = CompactRaidFrameContainer
			local t = {
				discrete = "flush",
				flush = "discrete",
			}

			if issecurevariable("CompactRaidFrame1") or InCombatLockdown() or not container:IsShown() then return end

			local mode = container.groupMode

			CompactRaidFrameContainer_SetGroupMode(container, t[mode])
			CompactRaidFrameContainer_SetGroupMode(container, mode)
			
		else
			return
		end
	end)
end

if Cfg.NamesColorize.FriendListColorize then
	local function DecimalToHex(r,g,b)
		return string.format("|cff%02x%02x%02x", r*255, g*255, b*255)
	end

	function Hook_FriendsList_Update()
		local friendOffset = HybridScrollFrame_GetOffset(FriendsFrameFriendsScrollFrame)
		if not friendOffset then
			return
		end
		if friendOffset < 0 then
			friendOffset = 0
		end

		local numBNetTotal, numBNetOnline = BNGetNumFriends()
		if numBNetOnline > 0 then
			for i=1, numBNetOnline, 1 do
				local _, realName, _, _, toonName, toonID, client, _, _, _, _, _, _, _, _ = BNGetFriendInfo(i)
				if client == BNET_CLIENT_WOW then
					local _, _, _, realmName, _, _, _, class, _, zoneName, level, _ = BNGetToonInfo(toonID)
					for k,v in pairs(LOCALIZED_CLASS_NAMES_MALE) do if class == v then class = k end end
					if GetLocale() ~= "enUS" then
						for k,v in pairs(LOCALIZED_CLASS_NAMES_FEMALE) do if class == v then class = k end end
					end
					local classc = (CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS)[class]
					if not classc then
						return
					end
					local nameString = _G["FriendsFrameFriendsScrollFrameButton"..(i-friendOffset).."Name"]
					if nameString then
						nameString:SetText(realName.." ("..DecimalToHex(classc.r, classc.g, classc.b)..toonName.."|r, "..LEVEL_ABBR.." "..level..")")
					end
					if CanCooperateWithToon(toonID) ~= true then
						local nameString = _G["FriendsFrameFriendsScrollFrameButton"..(i-friendOffset).."Info"]
						if nameString then
							nameString:SetText(zoneName.." ("..realmName..")")
						end
					end
				end
			end
		end

		local numberOfFriends, onlineFriends = GetNumFriends()
		if onlineFriends > 0 then
			for i=1, onlineFriends, 1 do
				j = i + numBNetOnline
				local name, level, class, area, connected, status, note, RAF = GetFriendInfo(i);
				for k,v in pairs(LOCALIZED_CLASS_NAMES_MALE) do if class == v then class = k end end
				if GetLocale() ~= "enUS" then
					for k,v in pairs(LOCALIZED_CLASS_NAMES_FEMALE) do if class == v then class = k end end
				end
				local classc = (CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS)[class]
				if not classc then
					return;
				end
				if connected then
					local nameString = _G["FriendsFrameFriendsScrollFrameButton"..(j-friendOffset).."Name"]
					if nameString and name then
						nameString:SetText(DecimalToHex(classc.r, classc.g, classc.b)..name.."|r, "..LEVEL_ABBR.." "..level);
					end
				end
			end
		end
	end;
	hooksecurefunc("FriendsList_Update", Hook_FriendsList_Update)
	hooksecurefunc("HybridScrollFrame_Update", Hook_FriendsList_Update)
end
